{
 Dmonstration d'utilisation de ClientCMDSocket et ServerCMDSocket avec :
 - envoi de commandes avec ou sans arguments (chanes, entiers, dcimaux, boolens, streams)
 - envoi de commandes avec dlai de timeout pour une rponse
 - envoi de fichiers (jusqu' 20 Mo)

 Ces composants sont drivs de TClientCMDSocket et TServerCMDSocket contenus dans le package "Composants Socket Borland" inclus dans
 ($Delphi)\Bin\dclsocketsXX.bpl (non install par dfaut)

 Test sous Delphi 7 et XE.

 Columbo pour phidels.com

 version 1.1 (03/11/2012) : Modification des paramtres de l'vnement d'erreur (client & serveur)
 version 1.0 (03/09/2012)
}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ScktComp, ComCtrls, ShellAPI, Math, SocketCommand;

type
  TIntegerObject = class(TObject)
    SocketHandle: integer;
  end;

  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    GroupBox2: TGroupBox;
    Panel3: TPanel;
    Label5: TLabel;
    LogClient: TMemo;
    GroupBox1: TGroupBox;
    Panel4: TPanel;
    BoutonServeur_Etat: TButton;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    EditServeur_EnvoyerCommande: TEdit;
    BoutonServeur_EnvoyerCommande: TButton;
    BoutonServeur_Fichier: TButton;
    EditServeur_Fichier: TEdit;
    BoutonServeur_FichierSelection: TButton;
    ListeClients: TListBox;
    Panel1: TPanel;
    Label2: TLabel;
    LogServeur: TMemo;
    BoutonServeur_DeconnecterClients: TButton;
    StatusBarServeur: TStatusBar;
    StatusBarClient: TStatusBar;
    Panel2: TPanel;
    Label1: TLabel;
    Label3: TLabel;
    BoutonClient_Client: TButton;
    EditClient_Fichier: TEdit;
    BoutonClient_Fichier: TButton;
    EditClient_MotClient: TEdit;
    BoutonClient_Inverser: TButton;
    EditClient_MotServeur: TEdit;
    BoutonClient_FichierSelection: TButton;
    NouveauClient: TButton;
    EditClient_AdresseServeur: TEdit;
    Label6: TLabel;
    ServerCMDSocket: TServerCMDSocket;
    ClientCMDSocket: TClientCMDSocket;
    BoutonClient_Inconnue: TButton;
    BoutonServeur_EnvoyerCommandeInconnue: TButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Client_Timeout: TUpDown;
    Client_TimeOutValue: TEdit;
    Label7: TLabel;
    BoutonClient_PING: TButton;
    Label8: TLabel;
    PONG: TShape;
    Label_PONG: TLabel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    procedure BoutonServeur_EtatClick(Sender: TObject);
    procedure BoutonClient_ClientClick(Sender: TObject);
    procedure BoutonServeur_DeconnecterClientsClick(Sender: TObject);
    procedure BoutonServeur_EnvoyerCommandeClick(Sender: TObject);
    procedure BoutonClient_FichierClick(Sender: TObject);
    procedure BoutonClient_InverserClick(Sender: TObject);
    procedure BoutonServeur_FichierClick(Sender: TObject);
    procedure BoutonServeur_FichierSelectionClick(Sender: TObject);
    procedure ClientCMDSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientCMDSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerCMDSocketClientError(Sender: TObject;
      Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
      var ErrorCode: Integer);
    procedure ClientCMDSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure ServerCMDSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerCMDSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ListeClientsClick(Sender: TObject);
    procedure NouveauClientClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServerCMDSocketClientCommand(Sender: TServerCMDSocket;
      Socket: TServerClientCMDSocket; CommandEx: TCommandUser);
    procedure ServerCMDSocketClientCommandError(Sender: TServerCMDSocket;
      Socket: TServerClientCMDSocket; CommandEx: TCommandUser; ErrTyp: TCMDSCError;
      var Continue: LongBool);
    procedure ClientCMDSocketCommandError(Sender: TClientCMDSocket;
      CommandEx: TCommandUser; ErrTyp: TCMDSCError; var Continue: LongBool);
    procedure ClientCMDSocketCommand(Sender: TClientCMDSocket;
      CommandEx: TCommandUser);
    procedure ServerCMDSocketClientCommandTimeOut(Sender: TServerCMDSocket;
      Socket: TServerClientCMDSocket; Command, ID: AnsiStr;
      TimeOut: Cardinal);
    procedure ClientCMDSocketCommandTimeOut(Sender: TClientCMDSocket; Command,
      ID: AnsiStr; TimeOut: Cardinal);
    procedure BoutonServeur_EnvoyerCommandeInconnueClick(Sender: TObject);
    procedure BoutonClient_InconnueClick(Sender: TObject);
    procedure BoutonClient_PINGClick(Sender: TObject);
  private
  public
  end;


const AUTOCONNECT='/c';
      CommandeInconnue=AnsiString('BLABLA');

var Form1: TForm1;
    ID_PING: AnsiString='';

implementation

{$R *.dfm}

/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////  Fonctions /////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Renvoie le nom du premier fichier commenant par File_Name et qui n'existe pas dans le rpertoire de l'excutable
function NomFichierLibre(File_Name: String): string;
var i: integer;
begin
     result:=ExtractFilePath(ParamStr(0))+File_Name;
     if FileExists(result) then
     begin
          i:=1;
          repeat
                Inc(i);
                result:=ExtractFilePath(ParamStr(0))+ChangeFileExt(File_Name, ' ('+inttostr(i)+')'+ExtractFileExt(File_Name));
          until not FileExists(result);
     end;
end;

// Inverse une chane de caractres
function Inverser(Chaine: string): string;
var i: integer;
begin result:=''; for i:=length(Chaine) downto 1 do result:=result+Chaine[i]; end;

// Ajoute une information horodate dans un Memo
procedure AjouterLog(Log: TMemo ; Texte: string);
begin Log.Lines.Add(FormatDateTime('(hh:nn:ss:zzzz) ', Now)+Texte); end;

/////////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Application ////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Connexion automatique au dmarrage selon le paramtre de la ligne de commande
procedure TForm1.FormCreate(Sender: TObject);
begin Randomize; if ParamStr(1)=AUTOCONNECT then BoutonClient_ClientClick(nil); end;

// Application : Ouverture d'une autre instance pour crer nouveau client
procedure TForm1.NouveauClientClick(Sender: TObject);
begin ShellExecute(Handle, 'open', PChar(ParamStr(0)), AUTOCONNECT, nil, SW_SHOWNORMAL); end;

// Application : Slection d'un fichier
procedure TForm1.BoutonServeur_FichierSelectionClick(Sender: TObject);
begin
     if OpenDialog1.Execute then
          if Sender=BoutonServeur_FichierSelection then EditServeur_Fichier.Text:=OpenDialog1.FileName
                                                   else EditClient_Fichier.Text:=OpenDialog1.FileName;
end;

// Application : Mise  jour des composants selon la slection des clients
procedure TForm1.ListeClientsClick(Sender: TObject);
var Trouve: bool;
    i: integer;
begin
     i:=0; Trouve:=false; while (i<ListeClients.Count) and not Trouve do if ListeClients.Selected[i] then Trouve:=true else Inc(i);
     BoutonServeur_EnvoyerCommande.Enabled:=Trouve;
     BoutonServeur_EnvoyerCommandeInconnue.Enabled:=Trouve;
     BoutonServeur_Fichier.Enabled:=Trouve;
     BoutonServeur_DeconnecterClients.Enabled:=Trouve;
end;

/////////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Serveur ////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Serveur : Dmarrage / Arrt
procedure TForm1.BoutonServeur_EtatClick(Sender: TObject);
begin
     (Sender as TButton).Enabled:=false;
     try
        ServerCMDSocket.Active:=not ServerCMDSocket.Active;
     except
       on E: Exception do AjouterLog(LogServeur, E.Message);
     end;
     (Sender as TButton).Enabled:=true;
     ListeClients.Clear;
     ListeClientsClick(nil);
     if ServerCMDSocket.Active then StatusBarServeur.SimpleText:='Serveur actif' else StatusBarServeur.SimpleText:='Serveur stopp';
     AjouterLog(LogServeur, StatusBarServeur.SimpleText);
end;

// Serveur : Dconnexion des clients slectionns
procedure TForm1.BoutonServeur_DeconnecterClientsClick(Sender: TObject);
var i, j: integer;
    Trouve: bool;
begin
     if ServerCMDSocket.Active then
     begin
          i:=0;
          while (i<ListeClients.Count) do
          begin
               if ListeClients.Selected[i] then
               begin
                    Trouve:=false;
                    for j:=0 to ServerCMDSocket.Socket.ActiveConnections-1 do
                      if ServerCMDSocket.Socket.Connections[j].SocketHandle=TIntegerObject(ListeClients.Items.Objects[i]).SocketHandle then
                      begin
                           Trouve:=true;
                           ServerCMDSocket.Socket.Connections[j].Close;
                      end;
                    if not Trouve then Inc(i);
               end else Inc(i);
          end;
     end;
end;

// Serveur : Envoi d'une commande inconnue aux clients slectionns
procedure TForm1.BoutonServeur_EnvoyerCommandeInconnueClick(Sender: TObject);
begin BoutonServeur_EnvoyerCommandeClick(nil); end;

// Serveur : Envoi d'un texte aux clients slectionns
procedure TForm1.BoutonServeur_EnvoyerCommandeClick(Sender: TObject);
var i, j: integer;
begin
     if ServerCMDSocket.Active then
       for i:=0 to ListeClients.Count-1 do
         if ListeClients.Selected[i] then
            for j:=0 to ServerCMDSocket.Socket.ActiveConnections-1 do
              if ServerCMDSocket.Socket.Connections[j].SocketHandle=TIntegerObject(ListeClients.Items.Objects[i]).SocketHandle then
              begin
                   if Sender=nil then
                   begin
                        ServerCMDSocket.Socket.Connections[j].SendCommand(CommandeInconnue, []);
                        AjouterLog(LogServeur, 'Envoi au client '+inttostr(ServerCMDSocket.Socket.Connections[j].SocketHandle)+' de la commande '+CommandeInconnue);
                   end
                   else
                   begin
                        ServerCMDSocket.Socket.Connections[j].SendCommand('TEXT', [AnsiString(EditServeur_EnvoyerCommande.Text)]);
                        AjouterLog(LogServeur, 'Envoi au client '+inttostr(ServerCMDSocket.Socket.Connections[j].SocketHandle)+' du texte : '+EditServeur_EnvoyerCommande.Text);
                   end;
              end;
end;

// Serveur : Envoi d'un fichier du serveur  tous les clients slectionns
procedure TForm1.BoutonServeur_FichierClick(Sender: TObject);
var i, j: integer;
    FS: TFileStream;
    Data: Variant;
begin
     FS:=TFileStream.Create(EditServeur_Fichier.Text, fmOpenRead or fmShareDenyNone);
     if FS.Size>MAX_ARRAY_SIZE then AjouterLog(LogServeur, 'La taille du fichier excde '+inttostr(MAX_ARRAY_SIZE)+' octets. Envoyez plusieurs trames pour viter la surcharge de mmoire.')
     else
     begin
          Data:=StreamToVariant(FS, FS.Size);
          if ServerCMDSocket.Active and FileExists(EditServeur_Fichier.Text) then
            for i:=0 to ListeClients.Count-1 do
              if ListeClients.Selected[i] then
                 for j:=0 to ServerCMDSocket.Socket.ActiveConnections-1 do
                   if ServerCMDSocket.Socket.Connections[j].SocketHandle=TIntegerObject(ListeClients.Items.Objects[i]).SocketHandle then
                   begin
                        ServerCMDSocket.Socket.Connections[j].SendCommand('FILE', [AnsiString(ExtractFileName(EditServeur_Fichier.Text)), Data]);
                        AjouterLog(LogServeur, 'Envoi au client '+inttostr(ServerCMDSocket.Socket.Connections[j].SocketHandle)+' du fichier '+ExtractFileName(EditServeur_Fichier.Text)+' ('+inttostr(FS.Size)+' octets)');
                   end;
          VarClear(Data);
     end;
     FS.Free;
end;

// Serveur : connexion d'un client
procedure TForm1.ServerCMDSocketClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var //ClientData: TSocketData;
    IntegerObject: TIntegerObject;
begin
     IntegerObject:=TIntegerObject.Create;
     IntegerObject.SocketHandle:=Socket.SocketHandle;
     ListeClients.AddItem('Handle '+inttostr(Socket.SocketHandle), IntegerObject);
     if ListeClients.Count=1 then
     begin
          ListeClients.Selected[0]:=true;
          ListeClientsClick(nil);
     end;
     AjouterLog(LogServeur, 'Connexion du client : '+inttostr(Socket.SocketHandle));
end;

// Serveur : dconnexion d'un client
procedure TForm1.ServerCMDSocketClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
var i: integer;
begin
     i:=0; while (i<ListeClients.Count) do if TIntegerObject(ListeClients.Items.Objects[i]).SocketHandle=Socket.SocketHandle then ListeClients.Items.Delete(i) else Inc(i);
     ListeClientsClick(nil);
     AjouterLog(LogServeur, 'Dconnexion du client : '+inttostr(Socket.SocketHandle));
end;

// Serveur : Erreur de socket
procedure TForm1.ServerCMDSocketClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin AjouterLog(LogServeur, SysErrorMessage(ErrorCode)); ErrorCode:=0; end;

// Serveur : Rception d'une commande transmise par un client
procedure TForm1.ServerCMDSocketClientCommand(Sender: TServerCMDSocket; Socket: TServerClientCMDSocket; CommandEx: TCommandUser);
var Chaine: string;
    FS: TFileStream;
    TC: cardinal;
begin
     if CommandEx.Reply_ID<>'' then Chaine:='rponse' else Chaine:='commande';
     AjouterLog(LogServeur, 'Rception d''une '+Chaine+' '+string(CommandEx.Command)+'.');
     if (CommandEx.Command='INVERT') and (length(CommandEx.Argument)=1) and VarIsType(CommandEx.Argument[0].Data, varString) then
         Socket.SendCommand(CommandEx.Command, [Inverser(CommandEx.Argument[0].Data)], 0, CommandEx.ID);
     if (CommandEx.Command='FILE') and (length(CommandEx.Argument)=2) and VarIsType(CommandEx.Argument[0].Data, varString) and VarIsArray(CommandEx.Argument[1].Data) then
     begin
          Chaine:=NomFichierLibre(CommandEx.Argument[0].Data);
          try
             FS:=TFileStream.Create(Chaine, fmCreate);
             try
                VariantToStream(CommandEx.Argument[1].Data, FS);
                AjouterLog(LogServeur, 'Fichier reu : '+ExtractFileName(Chaine)+' ('+inttostr(FS.Size)+' octets)');
             finally
                FS.Free;
             end;
          except
            AjouterLog(LogServeur, 'Erreur lors de la rception du fichier : '+ExtractFileName(Chaine));
          end;
     end;
     if CommandEx.Command='PING' then
     begin
          //Cration d'une fausse attente de 300 ms
          TC:=GetTickCount; while Abs(GetTickCount-TC)<300 do Application.ProcessMessages;
          Socket.SendCommand('PONG', [], 0, CommandEx.ID);
     end;
end;

// Serveur : Rception d'une commande inconnue ou d'une trame  la syntaxe incorrecte
procedure TForm1.ServerCMDSocketClientCommandError(Sender: TServerCMDSocket; Socket: TServerClientCMDSocket; CommandEx: TCommandUser; ErrTyp: TCMDSCError; var Continue: LongBool);
begin
     if ErrTyp=CMDSC_COMMAND_UNKNOWN then AjouterLog(LogServeur, 'Commande inconnue : '+string(CommandEx.Command)) else
     if ErrTyp=CMDSC_ILLEGAL_PARAMETER then AjouterLog(LogServeur, 'Paramtre incorrect : '+string(CommandEx.Command));
     Continue:=Random>0.5;
     if Continue then AjouterLog(LogServeur, 'Poursuite de l''analyse de la trame (dcision alatoire)')
                 else AjouterLog(LogServeur, 'Arrt de l''analyse de la trame (dcision alatoire)');
end;

// Serveur : Dlai d'attente dpass pour la rponse  une commande transmise  un client
procedure TForm1.ServerCMDSocketClientCommandTimeOut(Sender: TServerCMDSocket; Socket: TServerClientCMDSocket; Command, ID: AnsiStr; TimeOut: Cardinal);
begin AjouterLog(LogServeur, 'Aucune rponse du CLIENT '+inttostr(Socket.SocketHandle)+' ('+inttostr(Timeout)+' ms)  la commande '+string(Command)+'.'); end;

/////////////////////////////////////////////////////////////////////////////////
//////////////////////////////// Client /////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Client : connexion
procedure TForm1.ClientCMDSocketConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
     StatusBarClient.SimpleText:='Client connect';
     AjouterLog(LogClient, StatusBarClient.SimpleText);
     BoutonClient_Inverser.Enabled:=true; BoutonClient_Fichier.Enabled:=true; EditClient_AdresseServeur.Enabled:=false; BoutonClient_Inconnue.Enabled:=true; BoutonClient_Ping.Enabled:=true;
end;

// Client : dconnexion
procedure TForm1.ClientCMDSocketDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
     StatusBarClient.SimpleText:='Client dconnect';
     AjouterLog(LogClient, StatusBarClient.SimpleText);
     BoutonClient_Inverser.Enabled:=false; BoutonClient_Fichier.Enabled:=false; EditClient_AdresseServeur.Enabled:=true; BoutonClient_Inconnue.Enabled:=false; BoutonClient_Ping.Enabled:=false; PONG.Brush.Color:=clBtnFace; 
end;

// Client : Connexion / Dconnexion
procedure TForm1.BoutonClient_ClientClick(Sender: TObject);
begin
     BoutonClient_Client.Enabled:=false;
     if not ClientCMDSocket.Active then ClientCMDSocket.Host:=EditClient_AdresseServeur.Text;
     ClientCMDSocket.Active:=not ClientCMDSocket.Active;
     BoutonClient_Client.Enabled:=true;
end;

// Client : Erreur de Socket
procedure TForm1.ClientCMDSocketError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin AjouterLog(LogClient, SysErrorMessage(ErrorCode)); ErrorCode:=0; end;

// Client : Envoi d'une demande d'inversion de chane au serveur
procedure TForm1.BoutonClient_InverserClick(Sender: TObject);
begin if ClientCMDSocket.Active then ClientCMDSocket.SendCommand('INVERT', [AnsiString(EditClient_MotClient.Text)]); end;

// Client : Envoi d'un fichier au serveur
procedure TForm1.BoutonClient_FichierClick(Sender: TObject);
var FS: TFileStream;
    Data: Variant;
begin
     if ClientCMDSocket.Active and FileExists(EditClient_Fichier.Text) then
     begin
          FS:=TFileStream.Create(EditClient_Fichier.Text, fmOpenRead or fmShareDenyNone);
          if FS.Size>MAX_ARRAY_SIZE then AjouterLog(LogClient, 'La taille du fichier excde '+inttostr(MAX_ARRAY_SIZE)+' octets. Envoyez plusieurs trames pour viter la surcharge de mmoire.')
          else
          begin
               Data:=StreamToVariant(FS, FS.Size);
               ClientCMDSocket.SendCommand('FILE', [AnsiString(ExtractFileName(EditClient_Fichier.Text)), Data]);
               VarClear(Data);
               AjouterLog(LogClient, 'Envoi au serveur du fichier '+ExtractFileName(EditClient_Fichier.Text)+' ('+inttostr(FS.Size)+' octets)');
          end;
          FS.Free;
     end;
end;

// Client : Envoi d'une commande inconnue au serveur
procedure TForm1.BoutonClient_InconnueClick(Sender: TObject);
begin
     ClientCMDSocket.SendCommand(CommandeInconnue, []);
     AjouterLog(LogServeur, 'Envoi au serveur de la commande '+CommandeInconnue);
end;

// Client : Envoi d'un PING au serveur et attente de la rponse PONG
procedure TForm1.BoutonClient_PINGClick(Sender: TObject);
begin
     BoutonClient_PING.Enabled:=false;
     PONG.Brush.Color:=clBtnFace;
     PONG.Update;
     ID_PING:=ClientCMDSocket.SendCommand('PING', [], Client_Timeout.Position);
     if Client_Timeout.Position<>0 then AjouterLog(LogClient, 'Envoi au serveur de la commande PING (dlai de '+inttostr(Client_Timeout.Position)+' ms).')
                                   else AjouterLog(LogClient, 'Envoi au serveur de la commande PING.')
end;

// Client : Rception et traitement d'une commande en provenance du serveur
procedure TForm1.ClientCMDSocketCommand(Sender: TClientCMDSocket; CommandEx: TCommandUser);
var Chaine: string;
    FS: TFileStream;
begin
     if CommandEx.Reply_ID<>'' then Chaine:='rponse' else Chaine:='commande';
     AjouterLog(LogClient, 'Rception d''une '+Chaine+' '+string(CommandEx.Command)+'.');
     if (CommandEx.Command='INVERT') and (length(CommandEx.Argument)=1) and VarIsType(CommandEx.Argument[0].Data, varString) then
         EditClient_MotServeur.Text:=CommandEx.Argument[0].Data;
     if (CommandEx.Command='TEXT') and (length(CommandEx.Argument)=1) and VarIsType(CommandEx.Argument[0].Data, varString) then
         AjouterLog(LogClient, '"'+CommandEx.Argument[0].Data+'"');
     if (CommandEx.Command='FILE') and (length(CommandEx.Argument)=2) and VarIsType(CommandEx.Argument[0].Data, varString) and VarIsArray(CommandEx.Argument[1].Data) then
     begin
          Chaine:=NomFichierLibre(CommandEx.Argument[0].Data);
          try
             FS:=TFileStream.Create(Chaine, fmCreate);
             try
                VariantToStream(CommandEx.Argument[1].Data, FS);
                AjouterLog(LogClient, 'Fichier reu : '+ExtractFileName(Chaine)+' ('+inttostr(FS.Size)+' octets)');
             finally
                FS.Free;
             end;
          except
            AjouterLog(LogClient, 'Erreur lors de la rception du fichier : '+ExtractFileName(Chaine));
          end;
     end;
     if (CommandEx.Command='PONG') and (length(CommandEx.Argument)=0) then
       if CommandEx.Reply_ID=ID_PING then
       begin
            BoutonClient_PING.Enabled:=true;
            PONG.Brush.Color:=clLime;
       end
       else AjouterLog(LogClient, 'Rponse inattendue (dlai d''attente dpass ?)');
end;

// Client : Rception d'une commande inconnue ou d'une trame  la syntaxe incorrecte
procedure TForm1.ClientCMDSocketCommandError(Sender: TClientCMDSocket; CommandEx: TCommandUser; ErrTyp: TCMDSCError; var Continue: LongBool);
begin
     if ErrTyp=CMDSC_COMMAND_UNKNOWN then AjouterLog(LogClient, 'Erreur : Commande inconnue : '+string(CommandEx.Command)) else
     if ErrTyp=CMDSC_ILLEGAL_PARAMETER then AjouterLog(LogClient, 'Erreur : Paramtre incorrect : '+string(CommandEx.Command));
     Continue:=Random>0.5;
     if Continue then AjouterLog(LogClient, 'Poursuite de l''analyse de la trame (dcision alatoire)')
                 else AjouterLog(LogClient, 'Arrt de l''analyse de la trame (dcision alatoire)');
end;

// Client : Dlai d'attente dpass pour la rponse  une commande transmise au serveur
procedure TForm1.ClientCMDSocketCommandTimeOut(Sender: TClientCMDSocket; Command, ID: AnsiStr; TimeOut: Cardinal);
begin
     if (Command='PING') and (ID=ID_PING) then
     begin
          BoutonClient_PING.Enabled:=true;
          PONG.Brush.Color:=clRed;
          ID_PING:='';
     end;
     AjouterLog(LogClient, 'Aucune rponse du SERVEUR en '+inttostr(Timeout)+' ms  la commande '+string(Command)+'.');
end;

end.
